<?php

/*
Version 0.0.3 --- 01-12-2009 --- by FHN
*/

class NP_SimpleShop extends NucleusPlugin {
	function getEventList()   { return array('QuickMenu','PreSendContentType','PostAddItem','PreUpdateItem','PreDeleteItem','AddItemFormExtras','EditItemFormExtras'); }
	function getName()        { return 'SimpleShop'; }
	function getAuthor()      { return 'FHN.'; }
	function getURL()         { return ''; }
	function getVersion()     { return '0.0.2'; }
	function getDescription() { return ': , .'; }

	function supportsFeature($feature) {
		switch($feature) {
			case 'SqlTablePrefix': return 1;
			default: return 0;
		}
	}

	function hasAdminArea() {
		return 1;
	}
	
	function event_QuickMenu(&$data) {
		array_push(
			$data['options'],
			array(
				'title' => 'SimpleShop',
				'url' => $this->getAdminURL(),
				'tooltip' => ' '
			)
		);
	}

	function install() {
		$query ="CREATE TABLE IF NOT EXISTS `" . sql_table('plugin_simpleshop_item') . "` (" .
				"`item_id` int(11) unsigned NOT NULL auto_increment, " .
				"`price` varchar(255) NOT NULL default '', " .
				"`discount` varchar(255) NOT NULL default '0', " .
				"`available` int(11) NOT NULL default 0, " .
				"PRIMARY KEY (`item_id`)" .
				");";
		sql_query($query);
		$query ="CREATE TABLE IF NOT EXISTS `" . sql_table('plugin_simpleshop_order') . "` (" .
				"`id` int(11) unsigned NOT NULL auto_increment, " .
				"`member_id` int(11) unsigned NOT NULL, " .
				"`discount` varchar(255) NOT NULL default '0', " .
				"PRIMARY KEY (`id`)" .
				");";
		sql_query($query);
		$query ="CREATE TABLE IF NOT EXISTS `" . sql_table('plugin_simpleshop_order_content') . "` (" .
				"`id` int(11) unsigned NOT NULL auto_increment, " .
				"`order_id` int(11) unsigned NOT NULL, " .
				"`item_id` int(11) unsigned NOT NULL, " .
				"`quantity` int(11) NOT NULL default '1', " .
				"`price` varchar(255) NOT NULL default '0', " .
				"`discount` varchar(255) NOT NULL default '0', " .
				"PRIMARY KEY (`id`)" .
				");";
		sql_query($query);
		
		$this->createOption('cleardb', '     ?', 'yesno', 'no');
		$this->createOption('blog_shortname', '    :', 'text', '');
		$this->createOption('currency', '  (.)', 'text', '.');
		$this->createOption('available_type', '   ?', 'select', 'yesno', '"" / ""|yesno||bycount');
		
	} // install

	function unInstall() {
		if($this->getOption('cleardb') == "yes") {
			sql_query('DROP TABLE IF EXISTS ' . sql_table('plugin_simpleshop_item'));
			sql_query('DROP TABLE IF EXISTS ' . sql_table('plugin_simpleshop_order'));
			sql_query('DROP TABLE IF EXISTS ' . sql_table('plugin_simpleshop_order_content'));
		}
	} // unInstall


	function doSkinVar($skintype, $action) { // SimpleShop(cart)
		global $CONF, $manager;
		if($action == 'cart') {
			$crt=cookieVar('SShopCart'); //      itemid|quantity
			//$crt = $_COOKIE["SShopCart"];
			$crt_count=count($crt);
			if ($crt_count==0) {
				echo ' !';
			} else {
				//echo ' !';
				echo '<table class="ss_cart">';
				$totalprice=0;
				for ($i=0; $i<$crt_count; $i++) {
					$crtdata=explode("|",$crt[$i]);
					$itemid = $crtdata[0];
					//$itemcount = $crtdata[1];
					$item =& $manager->getItem($itemid,'','');
					$query = "SELECT price,discount FROM ".sql_table("plugin_simpleshop_item")." WHERE item_id=".$itemid;
					$res = mysql_query($query);
					$row = mysql_fetch_object($res);

					$Cart[$i][itemid] = $crtdata[0];
					$Cart[$i][quantity] = $crtdata[1];
					$Cart[$i][price] = intval($row->price);
					$Cart[$i][discount] = intval($row->discount);
					$Cart[$i][title] = strip_tags($item['title']);
					$Cart[$i][link] = createItemLink($itemid,'');
					$Cart[$i][currency] = $this->getOption('currency');
					$price = ($Cart[$i][price] - ($Cart[$i][price]/100)*$Cart[$i][discount])*$Cart[$i][quantity];
					$totalprice+=$price;
					echo '<tr class="item"><td class="title"><a href="'.$Cart[$i][link].'">'.$Cart[$i][title].'</a></td><td class="quantity">x'.$Cart[$i][quantity].'</td><td class="price">'.$price.' '.$Cart[$i][currency].'</td></tr>';
					
				}
				echo '<tr class="total"><td colspan="2" class="title"> :</td><td>'.$totalprice.' '.$Cart[$i][currency].'</td></tr>';
				echo '<tr class="order_cart"><td colspan="3"><a href="'.$CONF['MemberKey'].'"> </a></td></tr>';
				echo '</table>';

			} // if
			//print_r($_COOKIE);//  
		} // if
	} // doSkinVar

	function doTemplateVar(&$item,$field) { // SimpleShop(price|discount|resultprice|addtocart_button)
		global $blogid;
		//$params = func_get_args(); //   
		
		$blogid_opt = intval($this->_findBlogID($this->getOption('blog_shortname')));
		if ($blogid_opt == $blogid) {
		
			$item_id   = $item->itemid;
			//$rate      = postVar('rate');
			//$item_post = postVar('item_id');
			//$cookie    = cookieVar('NP_Rate-item'.$item_id);
 		
			if ($field == "price") {
				$query = "SELECT price FROM ".sql_table("plugin_simpleshop_item")." WHERE item_id=".$item_id;
				$res = mysql_query($query);
				$row = mysql_fetch_object($res);
				$price = intval($row->price);
				echo $price;
			} elseif ($field == "discount") {
				$query = "SELECT discount FROM ".sql_table("plugin_simpleshop_item")." WHERE item_id=".$item_id;
				$res = mysql_query($query);
				$row = mysql_fetch_object($res);
				$discount = intval($row->discount);
				echo $discount;
			} elseif ($field == "resultprice") {
				$query = "SELECT price,discount FROM ".sql_table("plugin_simpleshop_item")." WHERE item_id=".$item_id;
				$res = mysql_query($query);
				$row = mysql_fetch_object($res);
				$price = intval($row->price);
				$discount = intval($row->discount);
				$resultprice = $price - ($price/100*$discount);
				echo $resultprice;
			} elseif ($field == "addtocart_button") {
				echo '<form method="post">';
				echo '<input type="hidden" name="sshop_itemid" value="'.$item_id.'">';
				echo '<input type="submit" name="sshop_addtocart" value=" ">';
				echo '</form>';
			} else {
				
			}
		}
	} // doTemplateVar

	function event_PreSendContentType() {
		global $CONF;
		
		/* check for $_POST info */
		$itemtocart = postVar('sshop_itemid');
		if(!empty($itemtocart)) {
			$crt = $_COOKIE["SShopCart"];
			$crt_count = count($crt);
			if ($crt_count == 0) {
				SetCookie ("SShopCart[0]",$itemtocart."|1",time()+2592000,'/');// -   30 
			} else {
				$existincart = false;
				for ($i=0; $i < $crt_count; $i++) {
					$cartcont = explode("|",$crt[$i]);
					if ($cartcont[0] == $itemtocart) {
						$cartcont[1]++;
						$existincart = true;
					}
					SetCookie ("SShopCart[".$i."]",$cartcont[0]."|".$cartcont[1],time()+2592000,'/');// -   30 
				}
				if ($existincart == false) {
					SetCookie ("SShopCart[".$crt_count."]",$itemtocart."|1",time()+2592000,'/'); // $CONF['CookiePath'],$CONF['CookieDomain'],$CONF['CookieSecure']);// -   30 
				}
			}
			//$timestamp=time();
			//$expire = time()+2592000; //  
			//$item_post = postVar('item_id');
			//setCookie('SShopCart'.$item_post,$item_post,$expire,$CONF['CookiePath'],$CONF['CookieDomain'],$CONF['CookieSecure']);
			
			echo '<script language="JavaScript">location.href="'.serverVar('HTTP_REFERER').'";</script>';
			//header("Location: ".serverVar('HTTP_REQUEST')); 
		}
		
	} // PreSendContentType
	
	//   - ""      
    function event_PostAddItem(&$params) {
		global $member;
		$blogid = getBlogIDFromItemID($params['itemid']);
		if ($this->getOption('blog_shortname')==$this->_findBlogName($blogid)) {
			//, ,   - ...
			if ( $member->blogAdminRights($blogid) ) {
				$price = intval(postVar('plugin_simpleshop_price'));
				$discount = intval(postVar('plugin_simpleshop_discount'));
				$available = intval(postVar('plugin_simpleshop_available'));
			} else {			
				$price = 0;
				$discount = 0;
				$available = 0;
			}
			sql_query("INSERT INTO ".sql_table('plugin_simpleshop_item')." VALUES('".intval($params['itemid'])."','".$price."','".$discount."',".$available.")");
		}
    } // function
	
	//   - ""      
	function event_PreUpdateItem(&$params) {
		global $member;
		$blogid = getBlogIDFromItemID($params['itemid']);
		if ($this->getOption('blog_shortname')==$this->_findBlogName($blogid)) {
			if ($member->blogAdminRights($blogid)) {
				$price = intval(postVar('plugin_simpleshop_price'));
				$discount = intval(postVar('plugin_simpleshop_discount'));
				$available = intval(postVar('plugin_simpleshop_available'));
				sql_query("UPDATE ".sql_table('plugin_simpleshop_item')." SET price='".$price."', discount='".$discount."', available='".$available."' WHERE item_id='".intval($params['itemid'])."'");
			}
		}
	} // function

	//   - ""      
	function event_PreDeleteItem(&$params) {
		sql_query("DELETE FROM ".sql_table('plugin_simpleshop_item')." WHERE item_id='".intval($params['itemid'])."'");
	} // function
	
	//   - ""        
	function event_AddItemFormExtras(&$params) {
		$this->_generateForm('add');
		
    } // function

	//   - ""        
    function event_EditItemFormExtras(&$params) {
        //echo '<pre>';print_r($params);echo '</pre>';
        $itemid = $params['itemid'];
        $res = sql_query("SELECT price, discount, available FROM ".sql_table('plugin_simpleshop_item')." WHERE item_id=".$itemid);
        if (mysql_num_rows($res)) {
			//$price = intval(mysql_result($res,0));
			$row = mysql_fetch_object($res);
			$price = intval($row->price);
			$discount = intval($row->discount);
			$available = intval($row->available);
		} else {
			$price = '0';
			$discount = '0';
			$available = 0;
		}
        $this->_generateForm('',$price,$discount,$available);
    } // function
	
	//        
	function _generateForm($keywordstring,$price='0',$discount='0',$available=0) {
		global $member, $itemid;
		
		if ($keywordstring == 'add') {
			$blogid = intRequestVar('blogid');
			$keywordstring = '';
		} else {
			$blogid = getBlogIDFromItemID(intRequestVar('itemid'));
		}

		$bshortname = $this->_findBlogName($blogid);
		$ss_bshortname = $this->getOption('blog_shortname');
		//  ,    
		if ($bshortname == $ss_bshortname) {
			echo "<h3>SimpleShop</h3>\n";
			$available_type = $this->getOption('available_type');
			if ($member->blogAdminRights($blogid)) {
				echo '<p style="color: red; font-weight: bold;">';
				echo ': <input name="plugin_simpleshop_price" type="text" size="10" maxlength="10" value="'.$price.'" /> ';
				echo ': <input name="plugin_simpleshop_discount" type="text" size="10" maxlength="10" value="'.$discount.'" />% ';
				echo ': ';
				if ($available_type=='yesno') {
					echo '<input type="radio" name="plugin_simpleshop_available" value="1">   | ';
					echo '<input type="radio" name="plugin_simpleshop_available" value="0">  ';
				} elseif ($available_type=='bycount') {
					echo '<input type="text" name="plugin_simpleshop_available" type="text" size="10" maxlength="10" value="'.$available.'">';
				}
				echo '</p>';
			} else {
				echo '<p>: '.$price.' ';
				echo ': '.$discount.'%';
				echo ': ';
				if ($available_type=='yesno') {
					if ($available == 0) { echo ''; } else { echo ''; }
				} elseif ($available_type=='bycount') {
					echo $available;
				}
				echo '</p>';
			}
			echo "\n";
		} // if
	} // function
	
	function _findBlogID($name) {
		$q = "SELECT bnumber as result FROM " . sql_table('blog') . " WHERE bshortname='" . $name . "'";
		return quickQuery($q);
	} // function
	
	function _findBlogName($id) {
		$q = "SELECT bshortname as result FROM " . sql_table('blog') . " WHERE bnumber='" . $id . "'";
		return quickQuery($q);
	} // function

} // class
 
?>